import whatap.net as net
import whatap.agent.counter.counter_manager as counter
import whatap.agent.control.control_handler as control_handler
import whatap.downcheck as downcheck
import whatap.agentless.checkmain as agentless
import whatap.agent.conf.configure as config
from datetime import datetime, timedelta
import whatap.util.logging_util as logging_util
import whatap.agent.secure.security_master as secure
import whatap.net.tcpsession as tcpsession

module_loaded = datetime.now()

def boot():
    net.startNet()
    counter.startCounterManager()
    control_handler.initControlHandler()
    downcheck.startHello()
    agentless.start()


def isOK():
    ret = True
    if datetime.now() - module_loaded > timedelta(minutes= config.GetConfig().HealthCheckCoolTime ):
        logging_util.debug("AgentBoot.IsOK step -0")
        secu = secure.GetSecurityMaster()
        logging_util.debug("AgentBoot.IsOK step -1")
        ret = secu.pcode != 0
        logging_util.debug("AgentBoot.IsOK step -2 ", ret)
        ret = ret and (secu.oid != 0)
        logging_util.debug("AgentBoot.IsOK step -3 ", ret)
        ret = ret and tcpsession.isSessionOK()
        logging_util.debug("AgentBoot.IsOK step -4 ", ret)
        ret = ret and counter.isOK()
        logging_util.debug("AgentBoot.IsOK step -5 ", ret)

    return ret