import whatap.agent.conf.configure as config
from whatap.io.data_outputx import DataOutputX
import whatap.util.lib.pyaes as pyaes
from StringIO import StringIO

def NewCypher(cypher_key , xor_key ):
    cph = Cypher(cypher_key, xor_key)

    return cph

class Cypher:
    def __init__(self, cypher_key, xor_key):
        self.block = int(config.GetConfig().CypherLevel) / 8
        self.cypher_key = cypher_key[:self.block]
        self.xor_key = xor_key
        self.cypher = pyaes.AESModeOfOperationECB(self.cypher_key)

    def Encrypt(self, data_):
        if self.block == 0 or data_ is None:
            return data_

        dataLen = len(data_)
        remainder = dataLen % self.block
        if remainder == 0 :
            src = StringIO(data_)
            outputBufLen = dataLen
        else:
            buf = StringIO()
            buf.write(data_)
            buf.write('\0'*(self.block - remainder))
            buf.seek(0,0)
            src = buf
            outputBufLen = dataLen + (self.block - remainder)

        output = StringIO()

        while src.tell() < outputBufLen:
            output.write(self.cypher.encrypt(src.read(self.block)))

        return output.getvalue()

    def Decrypt(self, data_ ) :
        if self.block == 0 or self.cypher is None:
            return data_

        dataLen = len(data_)
        src = data_
        dst = StringIO()
        while len(src) > 0:
            dst.write(self.cypher.decrypt(src[:self.block]))
            src = src[self.block:]

        return dst.getvalue()

    def padding(self, src ):
        if len(src) == self.block:
            return src

        dest = ''+ self.block
        if len(src) > self.block:
            dest= src[:self.block]
        else:
            dest=  src

        return dest

    def Hide(self, data_):
        if self.block == 0 or self.xor_key is None:
            return data_

        buf = StringIO()
        keyLen = len(self.xor_key)
        dataLen = len(data_)
        j = 0
        for i in range(dataLen):
            buf.write(chr(ord(data_[i]) ^ ord(self.xor_key[j])))
            j = (j + 1) % keyLen

        return buf.getvalue()

def test():
    c = Cypher('0123456789123456', 0)
    encoded = c.Encrypt('hello world')

    o = StringIO()
    for c in encoded:
        o.write('%02x' % ord(c))
    print(encoded, o.getvalue())


if __name__ == '__main__':
    test()
