
import logging.handlers
import collections, copy
from StringIO import StringIO
from datetime import datetime
import os

debug_logger = logging.getLogger('DebugLogger')
debug_logger.setLevel(logging.DEBUG)

handler = logging.handlers.SysLogHandler()

debug_logger.addHandler(handler)

isDebug = bool(os.environ.get('WHATAP_DEBUG', False))
def debug(*args):
    global isDebug
    if isDebug:
        print("[DEBUG]", datetime.now().strftime('%Y-%m-%d %H:%M:%S'), " ".join([str(x) for x in args]))
        sys.stdout.flush()

def info(*args):
    print("[INFO]", " ".join([str(x) for x in args]))
    sys.stdout.flush()

def debugStack(e):
    debug(e)
    debug(getStackTrace())

import sys
import traceback

def getStackTrace ( ):
    exc_info = sys.exc_info()
    str_stack_trace = '\n'.join(traceback.format_exception(*(exc_info)))
    return str_stack_trace


queue = collections.deque(maxlen=50)

def logStack(e):
    now = datetime.now()
    logtime = now.strftime("%m/%d/%Y, %H:%M:%S")
    print(logtime, str(e), getStackTrace())
    queue.append( (logtime, str(e), getStackTrace()) )

def getAllLogs():
    buf = StringIO()
    for (timestamp, exception, stack) in copy.copy(queue):
        buf.write("\n%s %s\n"%(timestamp, exception))
        buf.write(stack)
        buf.write("\n")
    return buf.getvalue()