import subprocess, shlex
import time, os
from StringIO import StringIO

def executeCmd(command='getconf CLK_TCK'):
    process = subprocess.Popen(shlex.split(command), stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    buf = StringIO()
    while True:
        output = process.stdout.readline()
        if output == '' and process.poll() is not None:
            break
        buf.write(output)

    return buf.getvalue()

def executeCmdEx(command=None, uid=None, gid= None):
    if uid and gid:
        def preexec_fn():
            os.setgid(uid)
            os.setuid(gid)
        process = subprocess.Popen(shlex.split(command), stdout=subprocess.PIPE, stderr=subprocess.PIPE, preexec_fn= preexec_fn)
    else:
        process = subprocess.Popen(shlex.split(command), stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    buf = StringIO()
    while True:
        output = process.stdout.readline()
        return_code = process.poll()
        if output == '' and return_code is not None:
            break
        buf.write(output)

    return return_code, buf.getvalue()

def executeCommandSimple(command=[], output= None):
    process = subprocess.Popen(command, stdout=output, stderr=output)
    return process

def getSimpleDict(command=None):
    started=time.time()*1000
    process = subprocess.Popen(shlex.split(command), stdout=subprocess.PIPE)
    result = {}
    while True:
        output = process.stdout.readline().strip()
        #print 'getVmStat', output
        if not output and process.poll() is not None:
            break
        if output:
            #print 'getVmStat', output
            k, v = output.split()
            result[k] = v

    return result

def fixByteUnit(src):
    unit = {'k': 1024,'m': 1024*1024, 'g': 1024*1024*1024, 't': 1024*1024*1024*1024}
    try:
        src = int(float(src))
        return src
    except ValueError, e:
        src = int(float(src[:-1])) * unit[src[-1].lower()]

        return src


